'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.CmpBannerContainer = undefined;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _component = require('./component');

var _reactCmpModal = require('@s-ui/react-cmp-modal');

var _reactCmpModal2 = _interopRequireDefault(_reactCmpModal);

var _settings = require('../settings');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var CONSENT_STATUS_NOT_ACCEPTED = 'NOT_ACCEPTED';

var CmpBannerContainer = exports.CmpBannerContainer = function (_Component) {
  (0, _inherits3.default)(CmpBannerContainer, _Component);

  function CmpBannerContainer() {
    var _ref,
        _this2 = this;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, CmpBannerContainer);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = CmpBannerContainer.__proto__ || (0, _getPrototypeOf2.default)(CmpBannerContainer)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      showModal: false,
      showNotification: false
    }, _this.containerDOMEl = _react2.default.createRef(), _this._handleAccept = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee() {
      var _this$props, getPurposesAndVendors, sendConsents, _ref3, purposeConsents, vendorConsents;

      return _regenerator2.default.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _this$props = _this.props, getPurposesAndVendors = _this$props.getPurposesAndVendors, sendConsents = _this$props.sendConsents;
              _context.next = 3;
              return getPurposesAndVendors.execute();

            case 3:
              _ref3 = _context.sent;
              purposeConsents = _ref3.purposeConsents;
              vendorConsents = _ref3.vendorConsents;
              _context.next = 8;
              return sendConsents.execute({ purposeConsents: purposeConsents, vendorConsents: vendorConsents });

            case 8:
              _this.setState({ showModal: false, showNotification: false });
              _this._removeBodyEvent();

            case 10:
            case 'end':
              return _context.stop();
          }
        }
      }, _callee, _this2);
    })), _this._handleReadMore = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2() {
      return _regenerator2.default.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              _this.setState({ showModal: true, showNotification: false });

            case 1:
            case 'end':
              return _context2.stop();
          }
        }
      }, _callee2, _this2);
    })), _this._handleClickOnDocument = function (_ref5) {
      var target = _ref5.target;

      _this.containerDOMEl.current.contains(target) === false && _this._handleAccept();
    }, _this._handleExitModal = function () {
      _this.setState({ showModal: false });
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  /**
   * This handler is used everytime the user clicks on something in the web
   * in order to assume he's accepting our CMP if he's not trying to configure it and
   * he's just navigating the website
   */


  (0, _createClass3.default)(CmpBannerContainer, [{
    key: '_generateButtons',
    value: function _generateButtons() {
      var i18n = _settings.I18N[this.props.lang];
      return [{
        children: i18n.READ_MORE_BUTTON,
        negative: true,
        onClick: this._handleReadMore,
        size: 'small',
        type: 'tertiary'
      }, {
        children: i18n.ACCEPT_BUTTON,
        negative: true,
        onClick: this._handleAccept,
        size: 'large',
        type: 'primary'
      }];
    }
  }, {
    key: '_removeBodyEvent',
    value: function _removeBodyEvent() {
      document.removeEventListener('click', this._handleClickOnDocument, true);
    }
  }, {
    key: 'componentDidMount',
    value: function () {
      var _ref6 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee3() {
        var getConsentStatus, consentStatus;
        return _regenerator2.default.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                getConsentStatus = this.props.getConsentStatus;
                _context3.next = 3;
                return getConsentStatus.execute();

              case 3:
                consentStatus = _context3.sent;

                this.setState({
                  showNotification: consentStatus === CONSENT_STATUS_NOT_ACCEPTED
                });

                if (consentStatus === CONSENT_STATUS_NOT_ACCEPTED) {
                  // We're assuming, the user accepts our CMP if he keep navigating in our page
                  document.addEventListener('click', this._handleClickOnDocument, true);
                }

              case 6:
              case 'end':
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function componentDidMount() {
        return _ref6.apply(this, arguments);
      }

      return componentDidMount;
    }()
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this._removeBodyEvent();
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          companyName = _props.companyName,
          lang = _props.lang,
          logo = _props.logo,
          privacyUrl = _props.privacyUrl;

      return _react2.default.createElement(
        'div',
        { ref: this.containerDOMEl },
        this.state.showNotification && _react2.default.createElement(_component.CmpBanner, {
          buttons: this._generateButtons(),
          companyName: companyName,
          lang: lang
        }),
        this.state.showModal && _react2.default.createElement(_reactCmpModal2.default, {
          cmpReady: true,
          lang: lang,
          logo: logo,
          onExit: this._handleExitModal,
          privacyUrl: privacyUrl
        })
      );
    }
  }]);
  return CmpBannerContainer;
}(_react.Component);

CmpBannerContainer.propTypes = process.env.NODE_ENV !== "production" ? process.env.NODE_ENV !== "production" ? {
  companyName: _propTypes2.default.string.isRequired,
  getConsentStatus: _propTypes2.default.object.isRequired,
  getPurposesAndVendors: _propTypes2.default.object.isRequired,
  lang: _propTypes2.default.string,
  logo: _propTypes2.default.string,
  privacyUrl: _propTypes2.default.string,
  sendConsents: _propTypes2.default.object.isRequired
} : {} : {};